



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>线程androidAndroid ConditionVariable的用法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">线程androidAndroid ConditionVariable的用法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-09 05:29:27 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>查了好多资料，发现还是不全，干脆自己整理吧，至少保证在我的做法正确的，以免误导读者，也是给自己做个记录吧！</p>
<p>在Android开辟中，如果需要线程同步，可以使用Java系统库的wait()和notify()...但是这些代码的编写比拟麻烦。Android提供了一个ConditionVariable类便利线程同步操作。</p>
<p>ConditionVariable有三个方法，分别是block()、open()、close()。</p>
<p>void block()<br /> &nbsp; 阻塞当前线程，直到条件为open<br /> &nbsp; void block(long timeout)<br /> &nbsp; 阻塞当前线程，直到条件为open或超时<br /> &nbsp; void open()<br /> &nbsp; 释放全部阻塞的线程<br /> &nbsp; void close()<br /> &nbsp; 将条件重置为close</p>
<p>ConditionVariable 在创立时还有一种构造方法是 public ConditionVariable (boolean state) ，如果为true，默许时为opened，如果为false则是closed. ，默许public ConditionVariable()为closed.</p>
<p>自己简单写了一个Demo，效果有点牵强...Demo的效果是，TextView每过3秒，就会输出一个字符s。如果点击按钮可以马上输出。</p>
<div>&nbsp;&nbsp;&nbsp;&nbsp;每日一道理 <br />
人生是洁白的画纸，我们每个人就是手握各色笔的画师；人生也是一条看不到尽头的长路，我们每个人则是人生道路的远足者；人生还像是一块神奇的土地，我们每个人则是手握农具的耕耘者；但人生更像一本难懂的书，我们每个人则是孜孜不倦的读书郎。
</div>
<pre class="prettyprint linenums">public class MainActivity extends Activity implements OnClickListener {<br />
	private Button btn_output;<br />
	private TextView textView;<br />
	private MyHandler mHandler;<br />
	private boolean isStart;<br />
	private String str = "";<br />
	private ConditionVariable mConditionVariable;<br />
	private final int REFRESHTEXT = 1;<br />
	@Override<br />
	protected void onCreate(Bundle savedInstanceState) {<br />
		super.onCreate(savedInstanceState);<br />
		setContentView(R.layout.activity_main);<br />
		btn_output = (Button) findViewById(R.id.btn);<br />
		btn_output.setOnClickListener(this);<br />
		textView = (TextView) findViewById(R.id.txt);<br />
		mHandler = new MyHandler();<br />
		mConditionVariable = new ConditionVariable();<br />
		isStart = true;<br />
		new Thread(new Runnable() {<br />
			@Override<br />
			public void run() {<br />
				// TODO Auto-generated method stub<br />
				while(isStart) {<br />
					//延时等待3秒<br />
					mConditionVariable.block(3000);<br />
					//如果是点击了按钮，则先将条件重置，否则block会失效<br />
					mConditionVariable.close();<br />
					//线程唤醒后通知主线程更新TextView的文本<br />
					mHandler.sendEmptyMessage(REFRESHTEXT);<br />
				}<br />
			}<br />
		}).start();<br />
	}

	private class MyHandler extends Handler {<br />
		public void handleMessage(Message msg) {<br />
			switch(msg.what) {<br />
			case REFRESHTEXT:<br />
				textView.setText(str += 's');<br />
				break;<br />
			}<br />
		}<br />
	}

	@Override<br />
	public void onClick(View v) {<br />
		// TODO Auto-generated method stub<br />
		mConditionVariable.open();<br />
	}

	@Override<br />
	protected void onDestroy() {<br />
		// TODO Auto-generated method stub<br />
		super.onDestroy();<br />
		isStart = false;<br />
	}<br />
}</pre>
<p>文章结束给大家分享下程序员的一些笑话语录：</p>
<p>人工智能今天的发展水平：8乘8的国际象棋盘其实是一个体现思维与创意的强大媒介。象棋里蕴含了天文数字般的变化。卡斯帕罗夫指出，国际象棋的合法棋步共有1040。在棋局里每算度八步棋，里面蕴含的变化就已经超过银河系里的繁星总数。而地球上很少有任何数量达到这个级别。在金融危机之前，全世界的财富总和大约是1014人民币，而地球人口只有1010。棋盘上，所有可能的棋局总数达到10120，这超过了宇宙里所有原子的总数！经典语录网</p>
<p>---------------------------------<br />
           原创文章 By            <br />线程和android<br />---------------------------------</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvv0k1q.html">&lbrack;Unity3D&rsqb;巧妙利用父级子级实现Camera场景平面漫游</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy1gvdq.html">iOSIPV6简单测试环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4z7on9.html">phpcms v9 中的数据库操作函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qny2px8.html">Java用户线程和守护线程</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z470d9.html">压力测试报出503错误---ASP&period;NET支持大并发的相关配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93k67rq.html">HDU 1754 I Hate It</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydwzwgq.html">shell中awk用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdee67v9.html">http&colon;&sol;&sol;bootswatch&period;com&sol;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd4wrjq.html">新版Windows Azure CDN管理门户正式上线</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okrkd19.html">Android GradientDrawable类的详解，设置activity的背景颜色渐变效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm253l9.html">&lbrack;置顶&rsqb; 玩转Eclipse &mdash; 自动注释插件JAutodoc</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnod3pq.html">使用 AngularJS 从零构建大型应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eymw6z9.html">Java的URL来下载网页源码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpd3wr9.html">【vue系列之三】从一个vue-pdf-shower，说说vue组件和npm包</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me4lz6q.html">WebService之soap类型的服务和rest类型的服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zomwg3q.html">【原创】大数据基础之Impala（1）简介、安装、使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwkxm48.html">Zabbix Server 监控Web页面</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1lj7lq.html">&lbrack;译&rsqb;与TensorFlow的第一次接触（三）之聚类</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwlgg78.html">python基础介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv66my8.html">window&period;location API</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9rg5yvd8.html">hdu149850 years&comma; 50 colors &lpar;多个最小顶点覆盖&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zonoe9.html">Android注入事件的三种方法比较</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkdedz8.html">MonkeyRunner源码分析之－谁动了我的截图&quest;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1krjj69.html">Installshield获取安装包版本的系统变量是IFX&lowbar;PRODUCT&lowbar;VERSION</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdw3n79.html">《C语言及程序设计初步》网络课程主页</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mrp038.html">&period;Net IOC 之Unity</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdwgpy9.html">Gimp教程&colon;简约手机图标风格</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mry1n8.html">C&num;中抽象类和接口的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1krd269.html">Ibatis ISqlMapper工厂类案例</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mr1xn8.html">OAUTH协议简介</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
